_G.MaxCorpses = _G.MaxCorpses or {}
MaxCorpses.mod_path = ModPath
MaxCorpses._data_path = SavePath .. "MaxCorpses.txt"
MaxCorpses.options = {} 
MaxCorpses.options_menu = "MaxCorpses_menu"

function MaxCorpses:Save()
	local file = io.open( self._data_path, "w+" )
	if file then
		file:write( json.encode( self.options ) )
		file:close()
	end
end

function MaxCorpses:Load()
	local file = io.open( self._data_path, "r" )
	if file then
		self.options = json.decode( file:read("*all") )
		file:close()
	end
end

MaxCorpses:Load()

if MaxCorpses.options.maxvar == nil then 
	MaxCorpses.options.maxvar = 8
	MaxCorpses:Save()
end

MaxCorpses:Load()

Hooks:Add("LocalizationManagerPostInit", "MaxCorpses_loc", function(loc)
	LocalizationManager:add_localized_strings({
	    ["MaxCorpses_options_title"] = "MaxCorpses",
	    ["MaxCorpses_options_desc"] = "Change your Max Corpses",
  })
end)


	Hooks:Add("MenuManagerSetupCustomMenus", "MaxCorpsesOptions", function( menu_manager, nodes )
		MenuHelper:NewMenu( MaxCorpses.options_menu )
	end)

	Hooks:Add("MenuManagerPopulateCustomMenus", "MaxCorpsesOptions", function( menu_manager, nodes )
		MenuCallbackHandler.max_corpses = function(self, item)
			MaxCorpses.options.maxvar = math.floor(item:value())
			MaxCorpses:Save()
		end
	    MenuHelper:AddSlider({
            id = "max_corpses",
            title = "MaxCorpses_options_title",
            callback = "max_corpses",
            value = MaxCorpses.options.maxvar,
            min = 0,
            max = 250,
            step = 100,
            show_value = true,
            menu_id = MaxCorpses.options_menu,
            priority = 1  
		})  	 		  
	end )

	Hooks:Add("MenuManagerBuildCustomMenus", "MaxCorpsesOptions", function(menu_manager, nodes)
		nodes[MaxCorpses.options_menu] = MenuHelper:BuildMenu( MaxCorpses.options_menu )
		MenuHelper:AddMenuItem( MenuHelper.menus.lua_mod_options_menu, MaxCorpses.options_menu, "MaxCorpses_options_title", "MaxCorpses_options_desc", 1 )
	end)
	
if RequiredScript == "lib/managers/enemymanager" then
	MaxCorpses:Load()
	EnemyManager._MAX_NR_CORPSES = math.floor(MaxCorpses.options.maxvar)
	log(EnemyManager._MAX_NR_CORPSES)
end